package com.nisum.service;

import com.nisum.dao.Dao;
import com.nisum.dto.EmployeeDto;
import com.nisum.model.Employee;
import com.nisum.model.impl.EmployeeImp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.Optional;

@Service
public class EmployeeService {

  @Autowired
  @Qualifier(value = "EmployeeDao")
  private Dao employeeDao;

  public Collection<EmployeeImp> getAllEmployees() {
    return employeeDao.getAll();
  }

  public EmployeeImp  getEmployee(Integer employeeId) {
    Optional<EmployeeImp> employee = employeeDao.getById(employeeId);
    if (employee.isPresent()) {
      return employee.get();
    } else {
      return new EmployeeImp();
    }
  }

  public void createEmployee(EmployeeDto employee) {
    EmployeeImp newEmployee = new EmployeeImp();
    newEmployee.set(employee);
    employeeDao.save(newEmployee);
  }

  public void updateEmployee(Integer employeeId, EmployeeDto updatedEmployee) {
    Optional employeeToUpdate = employeeDao.getById(employeeId);
    if (employeeToUpdate.isPresent()) {
      EmployeeImp newEmployee = (EmployeeImp) employeeToUpdate.get();
      newEmployee.set(updatedEmployee);
      employeeDao.update(newEmployee);
    }
  }

  public void deleteEmployee(Integer employeeId) {
    Optional employeeToDelete = employeeDao.getById(employeeId);
    if (employeeToDelete.isPresent()) {
      employeeDao.delete(employeeToDelete.get());
    }
  }


}
